% path to libsvm
addpath('../../tools/libsvm-3.16/matlab');
% path to minFunc
addpath('../../tools/minFunc_2012/minFunc/');

% assme data is in libsvm format
[y, XX]=libsvmread('a1a');
y(y==-1) = 0;   % labels are in 0 and 1
[n, d]=size(XX);
XX=[XX, ones(n, 1)];  % with bias

w_init=rand(d+1, 1);    % with bias

m=XX*w_init;
% compute the likelihood
L=y'*m - sum(log(1+exp(m)))

Dim=d;

% gradient desecent, it worked
%for it=1:10
%  max_iter=3;
%  VV = w';  % variables, include the bias
%   [f, df] = CG_LOGISTIC(VV,Dim,XX, y);
%   w=w-0.0001 * df; %reshape(X(1:d+1), d+1, 1);
%end

% mark schmidt's minFunc
options.Display='none';
options.Method='cg';
[w,f,exitflag,output]=minFunc(@CG_LOGISTIC,w_init,options,Dim, XX,y);
m=XX*w;
L=y'*m - sum(log(1+exp(m)))
pause;

options.Method='sd';
[w,f,exitflag,output]=minFunc(@CG_LOGISTIC,w_init,options,Dim, XX,y);
m=XX*w;
L=y'*m - sum(log(1+exp(m)))
pause;
